var homunculus = require('homunculus');
var JsNode = homunculus.getClass('Node', 'es6');
var Token = homunculus.getClass('Token');

var Class = require('./util/Class');
var join = require('./join');

var DefaultValue = Class(function(jsdc) {
  this.jsdc = jsdc;
  this.hash = {};
}).methods({
  param: function(fmparams) {
    var self = this;
    if(fmparams.name() == JsNode.FMPARAMS && fmparams.size()) {
      var fnbody = fmparams.next().next().next().nid();
      fmparams.leaves().forEach(function(sgname) {
        if(sgname.name() == JsNode.SINGLENAME && sgname.size() == 2) {
          var init = sgname.last();
          if(init.name() == JsNode.INITLZ) {
            self.jsdc.ignore(init, 'default1', true);
            (self.hash[fnbody] = self.hash[fnbody] || []).push(sgname);
          }
        }
      });
    }
  },
  enter: function(fnbody) {
    var self = this;
    if(self.hash.hasOwnProperty(fnbody.nid())) {
      var sgnames = self.hash[fnbody.nid()];
      sgnames.forEach(function(sgname) {
        var id = sgname.first().first().token().content();
        self.jsdc.append('if(' + id + '===void 0)' + id);
        self.jsdc.append(join(sgname.last()));
        self.jsdc.append(';');
      });
    }
  }
});

module.exports = DefaultValue;
